import Flutter
import UIKit
import UserXKit

public class SwiftFlutterUserxPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "flutter_userx", binaryMessenger: registrar.messenger())
    let instance = SwiftFlutterUserxPlugin()
    registrar.addMethodCallDelegate(instance, channel: channel)
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    let args = call.arguments as? [String: Any]
    switch call.method {
    case "getPlatformVersion":
        result("iOS " + UIDevice.current.systemVersion)
    case "start":
        guard let apiKey = args?.first?.value as? String else { break }
        UserX.start(apiKey)
    case "setUserId":
        guard let userId = args?.first?.value as? String else { break }
        UserX.userId = userId
    case "addEvent":
        guard let eventName = args?["name"] as? String else { return }
        let eventAttrs = args?["attributes"] as? [String: Any]
        UserX.addEvent(eventName, with: eventAttrs)
    case "stopScreenRecording":
        UserX.stopScreenRecording()
    case "startScreenRecording":
        UserX.startScreenRecording()
    default:
        result(FlutterMethodNotImplemented)
    }
  }
}
